<script lang="ts">
import Vue from 'vue';
import ChevronLg from '../../static/nuxt-images/ico/chevron-lg.vue';
import SlpContainer from '../common/container.vue';
import SlpColumn from '../common/column.vue';
import SlpHorizontalRule from '../common/horizontal-rule.vue';

export default Vue.extend({
  name: 'SolutionsResourceCards',
  components: { SlpHorizontalRule, SlpColumn, SlpContainer, ChevronLg },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <SlpContainer>
    <SlpRow class="slp-mb-md-96 slp-mt-md-96 slp-mt-64">
      <div class="resources-block__header">
        <SlpTypography tag="h2" variant="heading2">
          {{ data.title || 'Resources' }}</SlpTypography
        >
        <SlpButton
          variant="ghost"
          href="/resources/"
          data-ga-name="view all resources"
          data-ga-location="resource cards"
          >View all resources
          <ChevronLg fill="#171321" direction="right" />
        </SlpButton>
      </div>
      <SlpHorizontalRule class="resources-block__line" />

      <SlpColumn
        v-for="(card, index) in data.cards"
        :key="index"
        :cols="data.column_size"
        class="slp-mb-md-48"
      >
        <a
          :href="card.href"
          class="resources-block"
          :data-ga-name="card.data_ga_name"
          :data-ga-location="card.data_ga_location"
          :data-aos="card.aos_animation"
          :data-aos-duration="card.aos_duration"
        >
          <div class="resources-block__wrapper">
            <div class="resources-block__content-top">
              <div class="resources-block__icon slp-flex">
                <img :src="card.icon" alt="" />
                <SlpTypography
                  tag="p"
                  variant="all-caps"
                  class="resources-block__type"
                  >{{ card.event_type }}
                </SlpTypography>
              </div>
              <img
                :src="
                  card.image ||
                  card.fallback_image ||
                  '/nuxt-images/resources/fallback/img-fallback-cards-infinity.png'
                "
                class="resources-block__image slp-my-24"
                alt=""
              />
              <SlpTypography tag="h3" variant="body1" class=""
                >{{ card.header }}
              </SlpTypography>
              <SlpTypography
                v-if="card.date"
                tag="p"
                variant="body1"
                class="slp-my-8"
                >{{ card.date }}
              </SlpTypography>
            </div>
            <div class="resources-block__content-bottom">
              <SlpTypography
                variant="button"
                tag="p"
                class="resources-block__link"
                >{{ card.link_text }}
                <ChevronLg fill="#171321" direction="right" />
              </SlpTypography>
            </div>
          </div>
        </a>
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style scoped lang="scss">
.slp-btn {
  color: $color-text-300;
}

.slp-text-button,
.slp-btn-ghost {
  font-weight: 600;
}

.slp-btn svg,
.resources-block__link svg {
  vertical-align: middle;
  margin-left: $spacing-4;
}

.resources-block {
  cursor: pointer;
  display: flex;
  position: relative;
  height: 100%;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    justify-content: space-between;
    padding: $spacing-32 $spacing-16;
    flex: 1;

    &:hover {
      background: $color-surface-900;
      border-bottom-right-radius: 100px;
    }
  }

  &__header {
    width: 100%;
    display: flex;
    flex-direction: column;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }
  }

  &__line {
    margin: $spacing-32 0;
    border-top: 2px solid $color-surface-400;
  }

  &__image {
    max-width: 100%;
    min-height: 235px;
    object-fit: cover;
  }

  &__link {
    color: $color-text-300;
    padding-left: 0;
  }

  &__type {
    text-transform: uppercase;
    margin-left: $spacing-8;
    letter-spacing: 1px;
  }

  &__content-top {
    p,
    h3 {
      color: $color-text-300;
    }
  }

  &__icon {
    img {
      max-width: 1rem;
    }
  }
}
</style>
